org 100h
  mov al,13h
  int 10h
  push 0xA000
  pop es
;  add dh,al
;  mov gs,dx  ; z-buffer

;  inc cx
PAL:
  mov dx,3C8h
  mov ax,cx
  out dx,al
  inc dx
  out dx,al
  shr al,1
  out dx,al
  shr al,1
  out dx,al
  loop PAL
  
; bp:particles
M:call GEN

;   mov cx,15
;   mov bx,-155
; PP:
;   add bx,cx
;   add bx,cx
;   inc bx
;   mov bp,40-100
;   mov al,127+64
;   mov si,cx
;   call PARTICLE
;   loop PP

  in al,60h
  cmp al,1
  jne M
  ret

PARTICLE: ; al=color ah=depth si=size bx=X bp=Y: [0 0] = center of screen
  pusha
  imul dx,si,2
PY:
  imul cx,si,2
PX:
  pusha
  sub dx,si
  sub cx,si
  add bp,dx
  add bx,cx

  imul dx,dx
  imul cx,cx
  add cx,dx
  add cx,si
  imul si,si
  cmp cx,si
  jg PE

  imul di,bx,205  ; column 0 is unfilled
  jo PE
  imul di,bp,320
  jo PE
  lea di,[di+bx+100*320+160]
;  cmp ah,[gs:di]
;  jae PE
  stosb
PE:
  popa

  loop PX
  dec dx
  jnz PY

  popa
  ret

GEN:
  mov sp,-2
  mov bx,1    ; random seed

; generate patricles: struct Particle { u16 X,Y,Z,Active; }
G:push sp     ; Active: non-zero
  imul bx,85
  mov ax,bx
  shr ax,2
  push ax     ; Z: 0..1/4
  imul bx,85
  push bx     ; Y: 0..1
  imul bx,85
  push bx     ; X: 0..1
  or sp,sp
  js G
  
; for each particle
  mov si,512*8 + 32768  ; 512 particles
I:

; find the closest neighbor
  mov ax,65535  ; best distance; bx = index (uninitialized)
  mov di,512*8 + 32768
J:
  cmp di,si
  je EJ
  
  push si
  
  ; compute squared distance dx^2 + dy^2 + dz^2
  xor bp,bp  ; sum
  mov cx,3
DJ:
  lodsw
  sub ax,[di]
  imul ax
  shr dx,2   ; keep sum < 48k even for far particles
  add bp,dx
  scasw  ; di+=2
  loop DJ
  
  ; new best?
  cmp ax,bp
  ja BJ
  xchg ax,bp
  mov bx,di
BJ:
  pop si
  
EJ:
  sub di,6+8
  js J
  
  ; bx=new best+6
  
  sub si,8
  js I
  
  ret
 


; void init(float t) {
;   static auto seed = time(0); srnd(seed, 1);
; //  static bool inited = false; if (inited) { return; } inited = true;
;   
;   n_fotouns = 0;
;   struct { v3 pos; float rad; bool active; } p[N_PARTICLES];
;   int n_active = N_PARTICLES;
;   
;   // Generate random particles in the initial volume [-2..2 -2..2 1..2].
;   for (int i=0; i<N_PARTICLES; i++) {
;     v3 r; do { r = v3{random(-1,1),random(-1,1),random(-1,1)}; } while (length2(r) > 1);
;     r = unit(r) * sqrtf(length(r));
;     p[i].pos = r * v3{3,3,0.75} + v3{0,0,1.5};
;     p[i].rad = 2;
;     p[i].active = true;
;   }
;   
;   for (int life=0; ; life++) {
;     for (int i=0; i<N_PARTICLES; i++) if (p[i].active) {
;       // Find the nearest particle.
;       int i_nearest = i; float d2_nearest = 1e30;
;       for (int j=0; j<N_PARTICLES; j++) if (j!=i && p[j].active) {
;         float d2 = distance2(p[i].pos, p[j].pos);
;         if (d2 < d2_nearest) { d2_nearest = d2; i_nearest = j; }
;       }
;       
;       // If the nearest particle is very close, let it absorb this one.
;       if (d2_nearest < D2_ABSORB) {
;         p[i_nearest].rad = sqrtf(SQ(p[i].rad) + SQ(p[i_nearest].rad));
;         p[i].active = false;
;         n_active--;
;       }
;       // Otherwise move towards the nearest particle and add this particle to the fotoun list.
;       else {
;         v3 dir = ((i_nearest==i? v3_0 : unit(p[i_nearest].pos - p[i].pos) * 0.025f) - 0.01f * v3_z) / p[i].rad + 0.005f*v3{random(-1,1),random(-1,1),random(-1,1)};
;         p[i].pos += dir;
;         gen_fotoun(fotoun{ p[i].pos, random(0.05,0.1)*v3{4,2,1}, p[i].rad*0.25f }, t, life);
; 
;         // add a blossom
;         if (p[i].rad <= 2) gen_fotoun(fotoun{ p[i].pos + 0.025f*v3{random(-2,2),random(-2,2),random(-1,1)}, random(0.75,1)*v3{1,0.5,0.75}, 2 }, t, life);
;         if (p[i].rad <= 4 && random()<0.25) gen_fotoun(fotoun{ p[i].pos + 0.025f*v3{random(-2,2),random(-2,2),random(-1,1)}, random(0.75,1)*v3{1,0.5,0.75}, 2 }, t, life);
;         if (p[i].rad <= 8 && random()<0.25) gen_fotoun(fotoun{ p[i].pos + 0.025f*v3{random(-2,2),random(-2,2),random(-1,1)}, random(0.75,1)*v3{1,0.5,0.75}, 2 }, t, life);
;         
;         if (p[i].pos.z < -2) { p[i].active = false; n_active--; }
;       }
;     }
;     if (n_active==0 || n_fotouns > MAX_FOTOUNS - N_PARTICLES) break;
;   }
; } 