N_PARTICLES equ 144
DIST_MIN equ 8
GRAVITY equ 96
;GRAVITY equ 0

org 100h
  mov al,13h
  int 10h
  push 0xA000
  pop es
;  add dh,al
;  mov gs,dx  ; z-buffer

;  inc cx
PAL:
  mov dx,3C8h
  mov ax,cx
  out dx,al
  inc dx
  out dx,al
  shr al,1
  out dx,al
  shr al,1
  out dx,al
  loop PAL

; bp:particles
M:
  mov sp,-8
  mov bx,1    ; pseudorandom seed

; generate patricles: struct Particle { u16 X,Y,Z,Active; }
G:
;  imul bx,85
;  mov ax,bx
;  sar ax,1
;  push ax     ; random(-0.25..0.25)

  push sp     ; [offset 6] .Active: yes

  imul bx,85
  push bx     ; [offset 4] .Z: random(-0.5..0.5)

  imul bx,85
  mov ax,bx
  or ah,80h
  push ax     ; [offset 2] .Y: random(-0.5..0)

  imul bx,85
  push bx     ; [offset 0] .X: random(-0.5..0.5)

  or sp,sp
  js G

; loop until there's one particle left
  mov cx,400
L:push cx

; for each particle
  mov si,N_PARTICLES*8 + 0x8000
I:
  cmp word[si+6],DIST_MIN ; active?
  jb EI

 ; find the nearest neighbor
  mov ax,65535  ; ax = best distance; bx = index (uninitialized)
  mov bx,si
  mov di,N_PARTICLES*8 + 0x8000
J:
  cmp di,si ; i!=j?
  je EJ
  cmp word[di+6],DIST_MIN ; active?
  jb EJ

  ; compute squared distance dX^2 + dY^2 + dZ^2
  push di
  push si
  push ax
  xor bp,bp  ; sum
  mov cx,3
DJ:
  lodsw
  sub ax,[di]
  imul ax    ; dx = dX^2 | dY^2 | dZ^2 (14-bit)
  add bp,dx  ; sum <= 48k
  scasw  ; di+=2
  loop DJ
  pop ax
  pop si
  pop di

  ; new best?
  cmp ax,bp
  jb EJ
  xchg ax,bp
  mov bx,di
EJ:
  sub di,8
  js J

 ; bx = nearest_neighbor
 ; kill this particle if the neighbor is very close
  mov [si+6],ax

 ; move this particle towards the nearest neighbor
  mov cl,3
MV:
  lodsw
  sub ax,[bx]

ISAR: ; bound the delta
  sar ax,1
  imul dx,ax,-64
  jo ISAR

  imul bp,85
  push bp
  sar bp,7
  add ax,bp
  pop bp
  
  sub [si-2],ax
  inc bx
  inc bx
  loop MV
  sub si,6

  add word[si+2],GRAVITY  ; .Y += gravity

 ; draw this particle
 ; al=color ah=depth di=size bx=X bp=Y: [0 0] = center of screen

;  mov dx,[si]  ; .X / 16
;  sar dx,4
;  idiv word[si+6]
;  xchg bx,ax ; X = .X / .Z

;  mov dx,[si+2]  ; .Y / 16
;  sar dx,4
;  idiv word[si+6]
;  xchg bp,ax ; Y = .Y / .Z

  pop cx
  push cx
  call DRAW

EI:
  sub si,8
  js I
  pop cx
  loop L

  in al,60h
  cmp al,1
  jne M
  int 20h

DRAW:  ; cx = iter
  pusha

  movsx bx,byte[si+1]  ; X
  movsx bp,byte[si+3]  ; Y

  mov ax,[si+4]  ; Z -> -16..16
  sar ax,12
  add al,32

  mov di,14
  shr cx,5
  sub di,cx      ; size ~ iter

; al=color ah=depth di=size bx=X bp=Y: [0 0] = center of screen

  imul dx,di,2
PY:
  imul cx,di,2
PX:
  pusha
  sub dx,di
  sub cx,di
  add bp,dx
  add bx,cx

  imul dx,dx  ; outside of the circle?
  imul cx,cx
  add cx,dx
  add cx,di
  imul di,di
  cmp cx,di
  jg PE

  imul di,bx,205  ; out of screen? (column 0 is unfilled)
  jo PE
  imul di,bp,320
  jo PE
  lea di,[di+bx+100*320+160]
;  cmp ah,[gs:di]
;  jae PE
  stosb
PE:
  popa

  loop PX
  dec dx
  jnz PY

  popa
  ret




; void init(float t) {
;   static auto seed = time(0); srnd(seed, 1);
; //  static bool inited = false; if (inited) { return; } inited = true;
;
;   n_fotouns = 0;
;   struct { v3 pos; float rad; bool active; } p[N_PARTICLES];
;   int n_active = N_PARTICLES;
;
;   // Generate random particles in the initial volume [-2..2 -2..2 1..2].
;   for (int i=0; i<N_PARTICLES; i++) {
;     v3 r; do { r = v3{random(-1,1),random(-1,1),random(-1,1)}; } while (length2(r) > 1);
;     r = unit(r) * sqrtf(length(r));
;     p[i].pos = r * v3{3,3,0.75} + v3{0,0,1.5};
;     p[i].rad = 2;
;     p[i].active = true;
;   }
;
;   for (int life=0; ; life++) {
;     for (int i=0; i<N_PARTICLES; i++) if (p[i].active) {
;       // Find the nearest particle.
;       int i_nearest = i; float d2_nearest = 1e30;
;       for (int j=0; j<N_PARTICLES; j++) if (j!=i && p[j].active) {
;         float d2 = distance2(p[i].pos, p[j].pos);
;         if (d2 < d2_nearest) { d2_nearest = d2; i_nearest = j; }
;       }
;
;       // If the nearest particle is very close, let it absorb this one.
;       if (d2_nearest < D2_ABSORB) {
;         p[i_nearest].rad = sqrtf(SQ(p[i].rad) + SQ(p[i_nearest].rad));
;         p[i].active = false;
;         n_active--;
;       }
;       // Otherwise move towards the nearest particle and add this particle to the fotoun list.
;       else {
;         v3 dir = ((i_nearest==i? v3_0 : unit(p[i_nearest].pos - p[i].pos) * 0.025f) - 0.01f * v3_z) / p[i].rad + 0.005f*v3{random(-1,1),random(-1,1),random(-1,1)};
;         p[i].pos += dir;
;         gen_fotoun(fotoun{ p[i].pos, random(0.05,0.1)*v3{4,2,1}, p[i].rad*0.25f }, t, life);
;
;         // add a blossom
;         if (p[i].rad <= 2) gen_fotoun(fotoun{ p[i].pos + 0.025f*v3{random(-2,2),random(-2,2),random(-1,1)}, random(0.75,1)*v3{1,0.5,0.75}, 2 }, t, life);
;         if (p[i].rad <= 4 && random()<0.25) gen_fotoun(fotoun{ p[i].pos + 0.025f*v3{random(-2,2),random(-2,2),random(-1,1)}, random(0.75,1)*v3{1,0.5,0.75}, 2 }, t, life);
;         if (p[i].rad <= 8 && random()<0.25) gen_fotoun(fotoun{ p[i].pos + 0.025f*v3{random(-2,2),random(-2,2),random(-1,1)}, random(0.75,1)*v3{1,0.5,0.75}, 2 }, t, life);
;
;         if (p[i].pos.z < -2) { p[i].active = false; n_active--; }
;       }
;     }
;     if (n_active==0 || n_fotouns > MAX_FOTOUNS - N_PARTICLES) break;
;   }
; }